# include <iostream>
# include <simplecpp>
# include <canvas.h>
# include <cstdio>
# include <cstring>

using namespace std;

void ins()
{
    cout<<"\n   INSTRUCTIONS : ";
    cout<<"\n Your goal is to get more gems into your mancala (the cup on the right) than the computer can get into its mancala (on the left).";
    cout<<"\n You get to start, then the computer takes its turn and so on.";
    cout<<"\n 1. You can only move gems on your side (which is the bottom row).";
    cout<<"\n 2. To move, you click on one of the cups in your row.  This picks up all the pieces in that cup and moves them counter-clockwise, putting one gem in each cup.";
    cout<<"\n 3. If the last gem of your move lands in your mancala, you get to go again.";
    cout<<"\n 4. If the last gem of your move lands in an empty cup on your side and there are gems in the computer's cup right across from it, then all the gems in both cups get put into your mancala.";




}


   //function for saving high score
int savehighscore(int board[],int &winner){
if(winner==0){return 0;}

char pl1nameinitial[20];
char pl2nameinitial[20];

char pl1name[20];
char pl2name[20];
int pl1score;
int pl2score;


cout<<"Give Name of First Player"<<endl;
cin>>pl1name;
cout<<"Give Name of Second Player"<<endl;
cin>>pl2name;



FILE* fp;
fp=fopen("csprojectsavedgame.txt","r");
if (fp == NULL){
cout << "Could not open saved file"<< endl;
return -1;
}
rewind(fp);
fscanf(fp,"  %s\n  %d\n  %s\n  %d\n",pl1nameinitial,&pl1score,pl2nameinitial,&pl2score);

rewind(fp);

fclose(fp);

fp=fopen("csprojectsavedgame.txt","w");

rewind(fp);


if(winner==1){
  if (pl1score>pl2score){if((board[6]/board[13])>(pl1score/pl2score))
                        fprintf(fp," %s\n  %d\n  %s\n  %d\n",pl1name,board[6],pl2name,board[13]);
                        }
                        else

                        if((board[6]/board[13])>(pl2score/pl1score)){fprintf(fp," %s\n  %d\n  %s\n  %d\n",pl1name,board[6],pl2name,board[13]);}


}
 if(winner==2)
    {if (pl1score>pl2score){
    if((board[13]/board[6])>(pl1score/pl2score)) {

    fprintf(fp," %s\n  %d\n  %s\n  %d\n",pl1name,board[6],pl2name,board[13]);
}

}
else
{
    if((board[13]/board[6])>(pl2score/pl1score)){fprintf(fp," %s\n  %d\n  %s\n  %d\n",pl1name,board[6],pl2name,board[13]);}}


}
rewind(fp);
 fclose(fp);

return 0;
}


void disphighscore()
{
    CHAR pl1nameinitial[20];
    CHAR pl2nameinitial[20];
    int pl1score;
    int pl2score;


    FILE* fp;
    fp= fopen("csprojectsavedgame.txt","r");
    if (fp == NULL){
    cout << "Could not open saved file"<< endl;
    return ;
    }
      rewind(fp);
    fscanf(fp," %s \n %d\n %s\n  %d\n",pl1nameinitial,&pl1score,pl2nameinitial,&pl2score);



    printf(" player 1 is %s\n player 1 score is %d\n player 2 is %s\n player 2 score is %d\n",pl1nameinitial,pl1score,pl2nameinitial,pl2score);
    rewind(fp);
    fclose(fp);
    return;
}


Text* dispvalue(int board[14]) // function which takes in values of houses and displays on screen
/*Team,Please take note
ALWAYS use this function as having syntax
beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
AND always use it in game() function.
*/
{

Text* house;
house= new Text [14];
if(house==NULL){cout<<"Memory Allocation Failure"<<endl;return house;}
house[0]= Text(350,260,board[0]);   house[7]= Text(850,140,board[7]);
house[1]= Text(450,260,board[1]);   house[8]= Text(750,140,board[8]);
house[2]= Text(550,260,board[2]);   house[9]= Text(650,140,board[9]);
house[3]= Text(650,260,board[3]);   house[10]= Text(550,140,board[10]);
house[4]= Text(750,260,board[4]);   house[11]= Text(450,140,board[11]);
house[5]= Text(850,260,board[5]);   house[12]= Text(350,140,board[12]);
house[6]= Text(985,200,board[6]);   house[13]= Text(215,200,board[13]);



return house;
}



void freedispmem(Text* retdispvalue){  //frees up dynamically allocated text array.Team, use this function ALWAYS before invoking dispvalue().-Pulkit

   if(retdispvalue!=NULL){delete []retdispvalue;}

   }

bool validholeclick(int a,int b, int c)  //a and b are coordinates of click and c is status of current player.
{
    int i;char valid='F';
    if (c == 1)
    {
    for(i=0;i<6;i++)
    {
        if(a<=(390+100*i) && a>=(310+100*i) && b<=300 && b>=220) { return true;}
    }
    if (valid=='F') {Text in1(900,390,"INVALID MOVE"); wait(2);return false;}
    }
    else if (c==2)
        {
    for(i=0;i<6;i++)
    {
        if(a<=(390+100*i) && a>=(310+100*i) && b<=180 && b>=100) { return true;}
    }
    if(valid=='F') {Text in2(900,390,"INVALID MOVE"); wait(2);return false;}
    }
    return true;
}




bool getbestmoveplayer(int tempboard[]){
    int temp;int capture;


    for(int holest=0;holest<=5;holest++){
         temp=tempboard[holest];
        if(temp==0){continue;}
        if ((temp==6-holest) ||(temp==19-holest))
            {
                return true;                     //confirmation for freeturn
            }
    }


    for(int holest=0;holest<=5;holest++){
         temp=tempboard[holest];
        if(temp==0){continue;}
         capture=temp+holest;//requied for captured
        if(0<=capture && capture<=5)
                {
                    if(tempboard[capture]==0){return true;}       //confirmation of captured
                }
        else if(13<=capture && capture<=17)
                {
                    if(tempboard[capture-13]==0){return true;}       //confirmation of captured(after one round)
                }
    }

    return false;

}


int playerfreeturn(int board[]){
    int temp;
   //Possibility 1: Check free turn.
   for(int holest=5;holest>=0;holest--){
     temp=board[holest];
     if(temp==0){continue;}

            if ((temp==6-holest) ||(temp==19-holest))
                {
                    return holest;              //confirmation for freeturn
                }
    }
    return -1;
}





int playercapture(int board[]){
    //Possibility 2 : Check captured.
    int temp;int capture;
    for(int holest=0;holest<=5;holest++){
        temp=board[holest];
        if(temp==0){continue;}
        capture=temp+holest;//requied for captured
            if(0<=capture && capture<=5)
                {
                    if(board[capture]==0){return holest;}       //confirmation of captured
                }
            else if(13<=capture && capture<=17)
                {
                    if(board[capture-13]==0){return true;}       //confirmation of captured(after one round)
                }
    }
    return -1;
}


int getbestmove(int board[]){
    int temp;int capture;int keep=1;int plfree;int plcapture;int cpl;//int tempboard[14];
   //Possibility 1: Check free turn.
   for(int holest=12;holest>=7;holest--){
     temp=board[holest];
     if(temp==0){continue;}

            if ((temp==13-holest)||(temp==26-holest))
                {
                    return holest;              //confirmation for freeturn
                }
    }
    //Possibility 2 : Check captured.
    for(int holest=7;holest<=12;holest++){
        temp=board[holest];
        if(temp==0){continue;}
        capture=temp+holest;//requied for captured
            if(7<=capture && capture<=12)
                {
                    if(board[capture]==0){return holest;}       //confirmation of captured
                }
            else if(20<=capture && capture<=24)
                {
                    if(board[capture-13]==0){return holest;}       //confirmation of captured(after one round)
                }

    }
        /*
    //Possibility 3:None of free turn or captured.

   for(int k=0;k<=13;k++){tempboard[k]=board[k];}

    for(int holest=12;holest>=7;holest--){

         temp=tempboard[holest];
         if(temp==0){continue;}

     for(int i=0;i<temp;)           //values in tempboard are updated for that holest.
                {
                if(holest==14-i-1) {holest=-i-1;}
                if(holest==6-i-1) {holest=7-i-1;}
                tempboard[holest+i+1]=tempboard[holest+i+1] + 1;
                i++;
                }

            if(!(getbestmoveplayer(tempboard))){ return holest;}

        for(int k=0;k<=13;k++){tempboard[k]=board[k];}

    }
    */

    //Possibility 4: Don't let player move his best move.


        plfree=playerfreeturn(board);
        if(plfree!=-1){
            for(int holest=12;holest>=7;holest--){
                temp=board[holest];if(temp==0){continue;}
            if(temp>=(plfree+1)){return holest;}
            }
        }


        plcapture=playercapture(board);
        if(plcapture!=-1){temp=board[plcapture];cpl=temp+plcapture;
            if(board[12-cpl]!=0){return (12-cpl);}
            else{
                for(int holest=12;holest>=7;holest--){temp=board[holest];if(temp==0){continue;}
                                                        if(temp>=(plcapture+1)){return holest;}
                }
            }
        }


    //Possibility 5: Nothing of the above.
    if(keep==0){
        for(int holest=7;holest<=12;holest++){
            if(board[holest]==0){continue;}
            else {keep=1;return holest;}
            }
    }
    if(keep==1){
        for(int holest=12;holest>=7;holest--){
            if(board[holest]==0){continue;}
            else {keep=0;return holest;}
        }
        }





return -1;
}


int game1()
{
        initCanvas("Mancala_Game",1200,550);
    int currplayer=1; // default status of the current player.

  Rectangle r1(600,200,1000,280),r2(600,475,200,50);

  Rectangle b1(300,390,200,50), b2(900,390,200,50);
    b1.setColor(COLOR("red")); b2.setColor(COLOR("red"));
  r1.setColor(COLOR("red"));
  r2.setColor(COLOR("red"));
  Text buttone(600,475,"EXIT");

  Rectangle mc1(215,200,150,200) , mc2(985,200,150,200);
  mc1.setColor(COLOR("blue"));
  mc2.setColor(COLOR("blue"));


  Circle h1(350,140,40) ,h2(450,140,40) , h3(550,140,40) ,h4(650,140,40) , h5(750,140,40) , h6(850,140,40);
  Circle h7(350,260,40) ,h8(450,260,40) , h9(550,260,40) ,h10(650,260,40) , h11(750,260,40) , h12(850,260,40);
  Text pl2(600,80,"Computer") , pl1(600,320,"Player_1");

  Line div1(300,340,300,200) , div2(300,200,900,200) , div3(900,200,900,60);
  div1.setColor(COLOR("yellow"));
  div2.setColor(COLOR("yellow"));
  div3.setColor(COLOR("yellow"));
  Text b1a(170,390,"TURN : "), b1b(290,390,"Player_");
  Text b1c(320,390,"1");

Text* retdispvalue;//returned value by dispvalue() function
int board[14];//array containing houses & mancalas
for(int i=0;i<=13;i++){board[i]=4;}
board[6]=0;board[13]=0;
retdispvalue=dispvalue(board);
if (retdispvalue == NULL)
    {cout<<"  Warning:Memory Not Allocated"<<endl;
    return -1;
    }



int holest, temp,freeturn,k,capture,winner;  //hole status.
repeat(100)
{
  int theclick = getClick();
  int cx = theclick/65536;
  int cy = theclick % 65536;


 if (cx<=700 && cx>=500 && cy<=500 && cy>=450)
 {
  freedispmem(retdispvalue);
  return 0;
 }
else if (validholeclick(cx,cy,currplayer))
    {

    if (currplayer == 1)
        {
        k=0;freeturn=2; //initaiating value of freeturn
        for(int i=0;i<6;i++)
            {
                if(cx<=(390+100*i) && cx>=(310+100*i) && cy<=300 && cy>=220) { holest=i;}
            }
        temp=board[holest];

        capture=temp+holest;//requied for captured
        if(0<=capture && capture<=5)
                {
                    if(board[capture]==0){k=1;}       //confirmation of captured(with in its zone)
                }
         if(13<=capture && capture<=17)
                {
                    if(board[capture-13]==0){k=1;}       //confirmation of captured(after one round)
                }


        if (temp==0) {Text in2(900,390,"NOT ALLOWED"); wait(2); continue; } //a hole with value 0 is not allowed to click
        board[holest]=0;

        if ((temp==6-holest)|| (temp==19-holest))
            {
                freeturn=1;                     //confirmation for freeturn
            }

        int m;
        m=holest;
        Circle ani1(350+100*(holest),260,15);   //ani=animation, initial circle at starting point
        for(int i=0;i<temp;)                     //value are updated
            { if (holest==(13-i-1)) {holest=-i-1;}
              board[holest+i+1]=board[holest+i+1] + 1;

                //propagation of circle
              if(i+m+1<6){ani1.moveTo(350+100*(m+i+1),260); }
              else if(i+m+1==6){ani1.moveTo(985,200);  }
              else if(i+m+1>6 && i+m+1<=12){ani1.moveTo(350+100*(12-(m+i+1)),140);  }
              else if(i+m+1>12 && i+m+1<=18){ani1.moveTo(350+100*((m+i+1)-13),260);  }
              else if(i+m+1==19){ani1.moveTo(985,200);  }
              else if(i+m+1>19 && i+holest+1<=25){ani1.moveTo(350+100*(25-(m+i+1)),140);  }



              beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame(); wait(1);i++;
            }



        if(k==1)                //updating value after captured
            {



                if(capture<=5){
                        board[6]=board[6]+1+board[12-capture];
                        board[12-capture]=0;
                        board[capture]=0;
                        Rectangle cap1(350+100*(capture),260,30,30);
                        Rectangle cap2(350+100*(capture),140,30,30);
                        Rectangle cap3(985,200,30,30);
                        wait(2);
                        beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();wait(1);
                        }
                else if(capture>=13 && capture<=17){
                        board[6]=board[6]+1+board[25-capture];
                        board[12-capture]=0;
                        board[capture-13]=0;
                        Rectangle cap1(350+100*(capture-13),260,30,30);
                        Rectangle cap2(350+100*(capture-13),140,30,30);
                        Rectangle cap3(985,200,30,30);
                        wait(2);
                        beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();wait(1);
                        }


            }
        //beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame(); wait(1);
        currplayer=freeturn;Text* b1c; b1c = new Text(320,390,currplayer); // next palyer turn

        if ((board[0]==0 && board[1]==0 && board[2]==0 && board[3]==0 && board[4]==0 && board[5]==0) ||
            (board[7]==0 && board[8]==0 && board[9]==0 && board[10]==0 && board[11]==0 && board[12]==0))
            {
              board[6]+=board[0]+board[1]+board[2]+board[3]+board[4]+board[5];
              board[13]+=board[7]+board[8]+board[9]+board[10]+board[11]+board[12];
              for(int k=0;k<=5;k++){board[k]=0;}
              for(int k=7;k<=12;k++){board[k]=0;}
              if(board[6]>board[13]){winner=1;}
              else if(board[6]<board[13]){winner=2;}
              else if(board[6]==board[13]){winner=0;}
                if(winner==1)
                {
                    Text b2a(900,377.5,"WINNER"),b2b(897,400,"Player_"),b2c(927,400,winner);
                     beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
                     while(true){
                                    XEvent event;
                                    nextEvent(event);
                                    if(mouseButtonPressEvent(event)){break;}
                                    else continue;
                                    }
                    freedispmem(retdispvalue);
                    if(b1c!=NULL){delete b1c;}
                    break;
                }

                else if (winner==2)
                {
                     Text b2a(900,377.5,"WINNER"),b2b(897,400,"Computer");
                     beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
                     while(true){
                                    XEvent event;
                                    nextEvent(event);
                                    if(mouseButtonPressEvent(event)){break;}
                                    else continue;
                                    }
                    freedispmem(retdispvalue);
                    if(b1c!=NULL){delete b1c;}
                    break;

                }

                else if(winner==0)
                {
                    Text b2a(900,377.5,"WINNER"), b2b(900,400,"Match is Draw");
                    beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
                     while(true){
                                    XEvent event;
                                    nextEvent(event);
                                    if(mouseButtonPressEvent(event)){break;}
                                    else continue;
                                    }
                    freedispmem(retdispvalue);
                    if(b1c!=NULL){delete b1c;}
                    break;
                }
            }
        if(freeturn==1)
                {
                Text in3(900,390,"FREE TURN"); wait(2); continue ;    //displaying  free turn
                }
        if(k==1)
            {
             Text in3(900,390,"CAPTURED"); wait(2); continue;        //displaying captured
            }

        }


    if (currplayer==2)
    {
        fturn:
        wait(2);
        k=0;freeturn=1;  //initaiating value of freeturn
        holest=getbestmove(board); // In single player hole status given by get best move function.
        if(holest==-1){cout<<"ERROR";return -1;}temp=board[holest];

            capture=temp+holest;//requied gor captured
            if (7<=capture && capture<=12)
                {
                    if(board[capture]==0){k=1;}       //confirmation of captured(with in zone)
                }
            if(20<=capture && capture<=24)
                {
                    if(board[capture]==0){k=1;}       //confirmation of captured(after one round)
                }


            if (temp==0) {Text in2(900,390,"NOT ALLOWED"); wait(2); k=0;goto fturn; }   //a hole with value 0 is not allowed to click
            board[holest]=0;

            if ((temp==13-holest)||(temp==26-holest))
                {
                    freeturn=2;              //confirmation for freeturn
                }
            int n;
            n=holest;     //n is for using value of holest during for loop for animation
            Circle ani1(350+100*(12-holest),140,15);   //initial circle at starting point
            for(int i=0;i<temp;)           //value are updated
                {
                if(holest==14-i-1) {holest=-i-1;}
                if(holest==6-i-1) {holest=7-i-1;}
                board[holest+i+1]=board[holest+i+1] + 1;

                 //propagation of circle
                if(i+n+1<13){ani1.moveTo(350+100*(12-(n+i+1)),140); }
                else if(i+n+1==13){ani1.moveTo(215,200);  }
                else if(i+n+1>13 && i+n+1<=13+6){ani1.moveTo(350+100*((n+i+1)-14),260);  }
                else if(i+n+1>13+6 && i+n+1<=13+12){ani1.moveTo(350+100*(25-(n+i+1)),140);  }
                else if(i+n+1==26){ani1.moveTo(215,200);  }
                else if(i+n+1>26 && i+n+1<=32){ani1.moveTo(350+100*((n+i+1)-27),260);  }


                beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame(); wait(1);i++;

                }

            if(k==1)                //updating value after captured
            {


                if(capture>=8 && capture<=12){
                        board[13]=board[13]+1+board[12-capture];
                        board[12-capture]=0;
                        board[capture]=0;
                        Rectangle cap1(350+100*(12-capture),260,30,30);
                        Rectangle cap2(350+100*(12-capture),140,30,30);
                        Rectangle cap3(215,200,30,30);
                        wait(2);
                        beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();wait(1);
                        }
                else if(capture>=20 && capture<=24){
                        board[13]=board[13]+1+board[25-capture];
                        board[25-capture]=0;
                        board[capture-13]=0;
                        Rectangle cap1(350+100*(25-capture),260,30,30);
                        Rectangle cap2(350+100*(25-capture),140,30,30);
                        Rectangle cap3(215,200,30,30);
                        wait(2);
                        beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();wait(1);
                        }



            }


            //beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
            currplayer=freeturn;Text* b1c; b1c= new Text(320,390,currplayer);    // next palyer turn

            if ((board[0]==0 && board[1]==0 && board[2]==0 && board[3]==0 && board[4]==0 && board[5]==0) ||
            (board[7]==0 && board[8]==0 && board[9]==0 && board[10]==0 && board[11]==0 && board[12]==0))
            {
              board[6]+=board[0]+board[1]+board[2]+board[3]+board[4]+board[5];
              board[13]+=board[7]+board[8]+board[9]+board[10]+board[11]+board[12];
              for(int k=0;k<=5;k++){board[k]=0;}
              for(int k=7;k<=12;k++){board[k]=0;}
              if(board[6]>board[13]){winner=1;}
              else if(board[6]<board[13]){winner=2;}
              else if(board[6]==board[13]){winner=0;}
                if(winner==1)
                {
                    Text b2a(900,377.5,"WINNER"),b2b(897,400,"Player_"),b2c(927,400,winner);
                     beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
                     while(true){
                                    XEvent event;
                                    nextEvent(event);
                                    if(mouseButtonPressEvent(event)){break;}
                                    else continue;
                                    }
                    freedispmem(retdispvalue);
                    if(b1c!=NULL){delete b1c;}
                    break;
                }

                else if (winner==2)
                {
                     Text b2a(900,377.5,"WINNER"),b2b(897,400,"Computer");
                     beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
                     while(true){
                                    XEvent event;
                                    nextEvent(event);
                                    if(mouseButtonPressEvent(event)){break;}
                                    else continue;
                                    }
                    freedispmem(retdispvalue);
                    if(b1c!=NULL){delete b1c;}
                    break;

                }

                else if(winner==0)
                {
                    Text b2a(900,377.5,"WINNER"), b2b(900,400,"Match is Draw");
                    beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
                     while(true){
                                    XEvent event;
                                    nextEvent(event);
                                    if(mouseButtonPressEvent(event)){break;}
                                    else continue;
                                    }
                    freedispmem(retdispvalue);
                    if(b1c!=NULL){delete b1c;}
                    break;

                }
            }
            if(freeturn==2)
                    {
                    Text in3(900,390,"FREE TURN"); wait(2); goto fturn;       //displaying  free turn
                    }
            if(k==1)
                {
                Text in3(900,390,"CAPTURED"); wait(2);k=0; continue;        //displaying captured
                }

    }
    }
}
savehighscore(board,winner);
return 0;

}


int game2()
{

    initCanvas("Mancala_Game",1200,550);
    int currplayer=1; // default status of the current player.

  Rectangle r1(600,200,1000,280),r2(600,475,200,50);

  Rectangle b1(300,390,200,50), b2(900,390,200,50);
    b1.setColor(COLOR("red")); b2.setColor(COLOR("red"));
  r1.setColor(COLOR("red"));
  r2.setColor(COLOR("red"));
  Text buttone(600,475,"EXIT");

  Rectangle mc1(215,200,150,200) , mc2(985,200,150,200);
  mc1.setColor(COLOR("blue"));
  mc2.setColor(COLOR("blue"));


  Circle h1(350,140,40) ,h2(450,140,40) , h3(550,140,40) ,h4(650,140,40) , h5(750,140,40) , h6(850,140,40);
  Circle h7(350,260,40) ,h8(450,260,40) , h9(550,260,40) ,h10(650,260,40) , h11(750,260,40) , h12(850,260,40);
  Text pl2(600,80,"Player_2") , pl1(600,320,"Player_1");

  Line div1(300,340,300,200) , div2(300,200,900,200) , div3(900,200,900,60);
  div1.setColor(COLOR("yellow"));
  div2.setColor(COLOR("yellow"));
  div3.setColor(COLOR("yellow"));
  Text b1a(170,390,"TURN : "), b1b(290,390,"Player_");
  Text b1c(320,390,"1");

Text* retdispvalue;//returned value by dispvalue() function
int board[14];//array containing houses & mancalas
for(int i=0;i<=13;i++){board[i]=4;}
board[6]=0;board[13]=0;
retdispvalue=dispvalue(board);
if (retdispvalue == NULL)
    {cout<<"  Warning:Memory Not Allocated"<<endl;
    return -1;
}

/*while(true){
XEvent event;
nextEvent(event);
if(mouseButtonPressEvent(event)){break;}
else continue;

}*/

//FRAME Change Code
/*The commands
beginFrame();
will cause all changes on the canvas to be temporarily withheld.any change will not be shown on the canvas till
endFrame();
command is issued.The current state of all the graphic elements will now be shown.*/
//Animation
/*1.After get click.
2.Create a circle c with centre as centre of the house and radius 20.
3.Use function "c.moveTo(//next coordinate of centre);wait(appropriately);"
4.And place it in for loop.*/

int holest, temp,freeturn,k,capture,winner;  //hole status.
repeat(100)
{
  int theclick = getClick();
  int cx = theclick/65536;
  int cy = theclick % 65536;


 if (cx<=700 && cx>=500 && cy<=500 && cy>=450)
 {
  freedispmem(retdispvalue);
  return 0;
 }
else if (validholeclick(cx,cy,currplayer))
    {

    if (currplayer == 1)
        {
        k=0;freeturn=2; //initiating value of freeturn
        for(int i=0;i<6;i++)
            {
                if(cx<=(390+100*i) && cx>=(310+100*i) && cy<=300 && cy>=220) { holest=i;}
            }
        temp=board[holest];

        capture=temp+holest;//requied gor captured

        if(0<=capture && capture<=5)
                {
                    if(board[capture]==0){k=1;}       //confirmation of captured(with in zone)
                }
        else if(13<=capture && capture<=17)
                {
                    if(board[capture-13]==0){k=1;}       //confirmation of captured(after one round)
                }
        if (temp==0) {Text in2(900,390,"NOT ALLOWED"); wait(2); continue; } //a hole with value 0 is not allowed to click

        board[holest]=0;

        if ((temp==6-holest) ||(temp==19-holest))
            {
                freeturn=1;                     //confirmation for freeturn
            }

         int m;
        m=holest;       //m is for using value of holest during for loop for animation
        Circle ani1(350+100*(holest),260,15);   //ani=animation, initial circle at starting point
        for(int i=0;i<temp;)                     //value are updated
            { if (holest==(13-i-1)) {holest=-i-1;}
              board[holest+i+1]=board[holest+i+1] + 1;

                //propagation of circle
              if(i+m+1<6){ani1.moveTo(350+100*(m+i+1),260); }
              else if(i+m+1==6){ani1.moveTo(985,200);  }
              else if(i+m+1>6 && i+m+1<=12){ani1.moveTo(350+100*(12-(m+i+1)),140);  }
              else if(i+m+1>12 && i+m+1<=18){ani1.moveTo(350+100*((m+i+1)-13),260);  }
              else if(i+m+1==19){ani1.moveTo(985,200);  }
              else if(i+m+1>19 && i+holest+1<=25){ani1.moveTo(350+100*(25-(m+i+1)),140);  }



              beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame(); wait(1);i++;
            }



        if(k==1)                //updating value after captured
            {



                if(capture<=5){
                        board[6]=board[6]+1+board[12-capture];
                        board[12-capture]=0;
                        board[capture]=0;
                        Rectangle cap1(350+100*(capture),260,30,30);
                        Rectangle cap2(350+100*(capture),140,30,30);
                        Rectangle cap3(985,200,30,30);
                        wait(2);
                        beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();wait(1);
                        }
                else if(capture>=13 && capture<=17){
                        board[6]=board[6]+1+board[25-capture];
                        board[12-capture]=0;
                        board[capture-13]=0;
                        Rectangle cap1(350+100*(capture-13),260,30,30);
                        Rectangle cap2(350+100*(capture-13),140,30,30);
                        Rectangle cap3(985,200,30,30);
                        wait(2);
                        beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();wait(1);
                        }



            }
        //beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame(); wait(1);
        currplayer=freeturn;Text* b1c; b1c = new Text(320,390,currplayer); // next palyer turn

        if ((board[0]==0 && board[1]==0 && board[2]==0 && board[3]==0 && board[4]==0 && board[5]==0) ||
            (board[7]==0 && board[8]==0 && board[9]==0 && board[10]==0 && board[11]==0 && board[12]==0))
            {
              board[6]+=board[0]+board[1]+board[2]+board[3]+board[4]+board[5];
              board[13]+=board[7]+board[8]+board[9]+board[10]+board[11]+board[12];
              for(int k=0;k<=5;k++){board[k]=0;}
              for(int k=7;k<=12;k++){board[k]=0;}
              if(board[6]>board[13]){winner=1;}
              else if(board[6]<board[13]){winner=2;}
              else if(board[6]==board[13]){winner=0;}
                if(winner==1||winner==2)
                {
                    Text b2a(900,377.5,"WINNER"),b2b(897,400,"Player_"),b2c(927,400,winner);
                     beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
                     while(true){
                                    XEvent event;
                                    nextEvent(event);
                                    if(mouseButtonPressEvent(event)){break;}
                                    else continue;
                                    }
                    freedispmem(retdispvalue);
                    if(b1c!=NULL){delete b1c;}
                    break;
                }
                else if(winner==0)
                {
                    Text b2a(900,377.5,"WINNER"), b2b(900,400,"Match is Draw");
                    beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
                     while(true){
                                    XEvent event;
                                    nextEvent(event);
                                    if(mouseButtonPressEvent(event)){break;}
                                    else continue;
                                    }
                    freedispmem(retdispvalue);
                    if(b1c!=NULL){delete b1c;}
                    break;
                }
            }


        if(freeturn==1)
                {

                Text in3(900,390,"FREE TURN"); wait(2); continue;    //displaying  free turn
                }

        if(k==1)
            {
                Text in3(900,390,"CAPTURED"); wait(2); continue;        //displaying captured
            }

        }


    else if (currplayer==2)
        {
            k=0;freeturn=1;  //initaiating value of freeturn
            for(int i=0;i<6;i++)
                {
                if(cx<=(390+100*i) && cx>=(310+100*i) && cy<=180 && cy>=100) { holest=12-i;}
                }
            temp=board[holest];

            capture=temp+holest;//requied gor captured
            if(7<=capture && capture<=12)
                {
                    if(board[capture]==0){k=1;}       //confirmation of captured(with in its zone)
                }
            else if(20<=capture && capture<=24)
                {
                    if(board[capture-13]==0){k=1;}       //confirmation of captured(after one round)
                }


            if (temp==0) {Text in2(900,390,"NOT ALLOWED"); wait(2); k=0;continue; }   //a hole with value 0 is not allowed to click
            board[holest]=0;

            if ((temp==13-holest)||(temp==26-holest))
                {
                    freeturn=2;              //confirmation for freeturn
                }

            int n;
            n=holest;      //n is for using value of holest during for loop for animation
            Circle ani1(350+100*(12-holest),140,15);   //initial circle at starting point
            for(int i=0;i<temp;)           //value are updated
                {
                if(holest==14-i-1) {holest=-i-1;}
                if(holest==6-i-1) {holest=7-i-1;}
                board[holest+i+1]=board[holest+i+1] + 1;

                  //propagation of circle
                if(i+n+1<13){ani1.moveTo(350+100*(12-(n+i+1)),140); }
                else if(i+n+1==13){ani1.moveTo(215,200);  }
                else if(i+n+1>13 && i+n+1<=13+6){ani1.moveTo(350+100*((n+i+1)-14),260);  }
                else if(i+n+1>13+6 && i+n+1<=13+12){ani1.moveTo(350+100*(25-(n+i+1)),140);  }
                else if(i+n+1==26){ani1.moveTo(215,200);  }
                else if(i+n+1>26 && i+n+1<=32){ani1.moveTo(350+100*((n+i+1)-27),260);  }

                beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame(); wait(1);i++;

                }

            if(k==1)                //updating value after captured
            {



                if(capture>=8 && capture<=12){
                        board[13]=board[13]+1+board[12-capture];
                        board[12-capture]=0;
                        board[capture]=0;
                        Rectangle cap1(350+100*(12-capture),260,30,30);
                        Rectangle cap2(350+100*(12-capture),140,30,30);
                        Rectangle cap3(215,200,30,30);
                        wait(2);
                        beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();wait(1);
                        }
                else if(capture>=20 && capture<=24){
                        board[13]=board[13]+1+board[25-capture];
                        board[25-capture]=0;
                        board[capture-13]=0;
                        Rectangle cap1(350+100*(25-capture),260,30,30);
                        Rectangle cap2(350+100*(25-capture),140,30,30);
                        Rectangle cap3(215,200,30,30);
                        wait(2);
                        beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();wait(1);
                        }

            }


            //beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
            currplayer=freeturn;Text* b1c; b1c= new Text(320,390,currplayer);    // next palyer turn

            if ((board[0]==0 && board[1]==0 && board[2]==0 && board[3]==0 && board[4]==0 && board[5]==0) ||
            (board[7]==0 && board[8]==0 && board[9]==0 && board[10]==0 && board[11]==0 && board[12]==0))
            {
              board[6]+=board[0]+board[1]+board[2]+board[3]+board[4]+board[5];
              board[13]+=board[7]+board[8]+board[9]+board[10]+board[11]+board[12];
              for(int k=0;k<=5;k++){board[k]=0;}
              for(int k=7;k<=12;k++){board[k]=0;}
              if(board[6]>board[13]){winner=1;}
              else if(board[6]<board[13]){winner=2;}
              else if(board[6]==board[13]){winner=0;}
                if(winner==1||winner==2)
                {
                    Text b2a(900,377.5,"WINNER"),b2b(897,400,"Player_"),b2c(927,400,winner);
                     beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
                     while(true){
                                    XEvent event;
                                    nextEvent(event);
                                    if(mouseButtonPressEvent(event)){break;}
                                    else continue;
                                    }
                    freedispmem(retdispvalue);
                    if(b1c!=NULL){delete b1c;}
                    break;
                }
                else if(winner==0)
                {
                    Text b2a(900,377.5,"WINNER"), b2b(900,400,"Match is Draw");
                    beginFrame();freedispmem(retdispvalue);dispvalue(board);endFrame();
                     while(true){
                                    XEvent event;
                                    nextEvent(event);
                                    if(mouseButtonPressEvent(event)){break;}
                                    else continue;
                                    }
                    freedispmem(retdispvalue);
                    if(b1c!=NULL){delete b1c;}
                    break;

                }
            }
            if(freeturn==2)
                    {
                    Text in3(900,390,"FREE TURN"); wait(2); continue;       //displaying  free turn
                    }
            if(k==1)
                {
                Text in3(900,390,"CAPTURED"); wait(2);k=0; continue;        //displaying captured
                }
        }

    }
}
savehighscore(board,winner);
return 0;
}


main_program
{  int ch; //ch=choice
   char ch2;
   int retgamevalue; //returned value by game() function
    char exitch;
    while (true) {
    cout<<"\n\n\n         :::::::::::::WELCOME TO MANCALA::::::::::::::";
    cout<<"\n           ::::::::::::::::::MAIN MENU::::::::::::::::::";
    cout<<"\n             1. Instructions (enter '1' as choice) ";
    cout<<"\n             2. Play (enter '2' as choice)";
    cout<<"\n             3. High Score Double player (enter '3' as choice)";
    cout<<"\n             4. Exit (enter '4' as choice)";
    cout<<"\n Enter choice : ";cin>>ch;
    switch(ch) {
        case 1: ins();
              break;
        case 2:
                cout<<"\n 1.Single Player (enter choice as 's') ";
                cout<<"\n 2.Double Player (enter choice as 'd') ";
                cout<<"\n Enter choice of players : ";
                cin>>ch2;
                if  (ch2=='s')
                {
                  retgamevalue = game1();
                  if(retgamevalue==-1)
                  {closeCanvas();cout<<"  Sorry ! Game needs to close down"<<endl;return 0;}
                  closeCanvas();
                }
                else if (ch2=='d')
                {
                    retgamevalue = game2();
                  if(retgamevalue==-1)
                  {closeCanvas();cout<<"  Sorry ! Game needs to close down"<<endl;return 0;}
                  closeCanvas();

                }
                else { cout<<"Invalid choice!!! Enter 's' or 'd' ";}



              break;
        case 3: disphighscore();
                break;
        case 4: cout<<"\n Are you sure you want to exit ? ( 'y'/'n') ";cin>>exitch;
             if (exitch=='y') {return 0;}
             else {continue;}

        default : cout<<"\n Invalid choice!!!"; break;
    }

}
}
